diff --git a/spring-test/src/main/java/org/springframework/test/context/support/ContextLoaderUtils.java b/spring-test/src/main/java/org/springframework/test/context/support/ContextLoaderUtils.java
index dfad07d231e..72d4f325c02 100644
--- a/spring-test/src/main/java/org/springframework/test/context/support/ContextLoaderUtils.java
+++ b/spring-test/src/main/java/org/springframework/test/context/support/ContextLoaderUtils.java
@@ -165,7 +165,7 @@ else if (contextHierarchyDeclaredLocally) {
 			// Declared on an enclosing class of an inner class?
 			if (desc == null && ClassUtils.isInnerClass(rootDeclaringClass)) {
 				desc = findAnnotationDescriptorForTypes(
-						rootDeclaringClass.getDeclaringClass(), searchStrategy, contextConfigType, contextHierarchyType);
+						rootDeclaringClass.getEnclosingClass(), searchStrategy, contextConfigType, contextHierarchyType);
 			}
 		}
 
diff --git a/spring-test/src/main/java/org/springframework/test/util/MetaAnnotationUtils.java b/spring-test/src/main/java/org/springframework/test/util/MetaAnnotationUtils.java
index e2309467f2b..9bdc0fd3ae8 100644
--- a/spring-test/src/main/java/org/springframework/test/util/MetaAnnotationUtils.java
+++ b/spring-test/src/main/java/org/springframework/test/util/MetaAnnotationUtils.java
@@ -157,7 +157,7 @@
 
 		// Declared on an enclosing class of an inner class?
 		if (searchStrategy == SearchStrategy.TYPE_HIERARCHY_AND_ENCLOSING_CLASSES && ClassUtils.isInnerClass(clazz)) {
-			descriptor = findAnnotationDescriptor(clazz.getDeclaringClass(), visited, annotationType, searchStrategy);
+			descriptor = findAnnotationDescriptor(clazz.getEnclosingClass(), visited, annotationType, searchStrategy);
 			if (descriptor != null) {
 				return descriptor;
 			}
@@ -274,7 +274,7 @@ private static UntypedAnnotationDescriptor findAnnotationDescriptorForTypes(@Nul
 
 		// Declared on an enclosing class of an inner class?
 		if (searchStrategy == SearchStrategy.TYPE_HIERARCHY_AND_ENCLOSING_CLASSES && ClassUtils.isInnerClass(clazz)) {
-			descriptor = findAnnotationDescriptorForTypes(clazz.getDeclaringClass(), searchStrategy, visited, annotationTypes);
+			descriptor = findAnnotationDescriptorForTypes(clazz.getEnclosingClass(), searchStrategy, visited, annotationTypes);
 			if (descriptor != null) {
 				return descriptor;
 			}
